#include <stdio.h>

#include "rat.h"

static int pgcd(int a, int b)
{
  int r;

  if ((a == 0) || (b == 0))
    return 1;

  if (a < 0) a = -a;
  if (b < 0) b = -b;

  if (a < b)
    {
      int tmp = a;
      a = b;
      b = tmp;
    }

  r = 1;
  while (r != 0)
    {
      r = a % b;
      a = b;
      b = r;
    }

  return a;
}

Rat rat_new(int num, int den)
{
  Rat r;
  int d;

  if (den == 0)
    printf("denominator null\n");

  if (num == 0)
    den = 1;

  if (den < 0)
    {
      num = -num;
      den = -den;
    }

  d = pgcd(num, den);
  r.num_ = num / d;
  r.den_ = den / d;

  return r;
}

void rat_disp(Rat r)
{
  printf("%d", r.num_);
  if (r.den_ != 1)
    printf("/%d\n", r.den_);
}

Rat rat_add(Rat r1, Rat r2)
{
  Rat r;

  r = rat_new(r1.num_ * r2.den_ + r1.den_ * r2.num_, r1.den_ * r2.den_);

  return r;
}

Rat rat_sub(Rat r1, Rat r2)
{
  Rat r;

  r = rat_new(r1.num_ * r2.den_ - r1.den_ * r2.num_, r1.den_ * r2.den_);

  return r;
}

Rat rat_mul(Rat r1, Rat r2)
{
  Rat r;

  r = rat_new(r1.num_ * r2.num_, r1.den_ * r2.den_);

  return r;
}

Rat rat_div(Rat r1, Rat r2)
{
  Rat r;

  if (r2.num_ == 0)
    printf("division by 0\n");

  r = rat_new(r1.den_ * r2.num_, r1.num_ * r2.den_);

  return r;
}
